!
! calcc2t --- calculate expectation value of cos^2 theta
! Robin Santra, Christian Buth
! 03 Apr 2007
!


      subroutine calcc2t(neq,ncols,n,Jmax,Kmax,Mmax,c2tmat,cos2t,  &
     &     A,B,temperature,Z,t)
!       use ridgidrotor         ! does not work yet
      use fortrantl
      implicit none

      integer neq,ncols
      integer Jmax,Kmax,Mmax
      complex(dblprec) n(neq,ncols)
      complex(dblprec) cos2t
      complex(dblprec) phase
      complex(dblprec) aux1,aux2,aux3,aux4
      real(dblprec) c2tmat(-2:2,neq,-Mmax:Mmax,-Kmax:Kmax)
      real(dblprec) A,B,temperature,beta,Z,t
      real(dblprec) Zaux

      integer J,K,M,init
      integer indc,indr,i,l,q

      real(dblprec) statweight
      external statweight

      beta = 1.0D0 / temperature
      cos2t = (0.d0,0.d0)

      indc = 0
      do J = 0, Jmax
         aux1 = (0.d0,0.d0)
         do K = -min(J, Kmax), min(J, Kmax)
            Zaux = B*dble(J*(J+1)) + (A-B)*dble(K**2)
            Zaux = beta*Zaux
            Zaux = dexp(-Zaux)/Z
            Zaux = Zaux * statweight(J, K, M)

            aux2 = (0.d0,0.d0)
            do M = -J, J
               indc = indc + 1
               init = max(abs(M),abs(K))
               aux3 = (0.d0,0.d0)

               indr = 1
               i = init + indr - 1
               aux4 = (0.d0,0.d0)
               do q = 0,2
                  l = i + q
                  phase = B*dble(i*(i+1)-l*(l+1))
                  phase = (0.d0,1.d0)*phase*t
                  phase = exp(phase)
                  aux4 = aux4 +                                 &
     &                 c2tmat(q,indr,M,K)*phase*n(indr+q,indc)
               end do
               aux3 = aux3 + conjg(n(indr,indc))*aux4

               indr = 2
               i = init + indr - 1
               aux4 = (0.d0,0.d0)
               do q = -1,2
                  l = i + q
                  phase = B*dble(i*(i+1)-l*(l+1))
                  phase = (0.d0,1.d0)*phase*t
                  phase = exp(phase)
                  aux4 = aux4 +                                 &
     &                 c2tmat(q,indr,M,K)*phase*n(indr+q,indc)
               end do
               aux3 = aux3 + conjg(n(indr,indc))*aux4

               do indr = 3, neq-2
                  i = init + indr - 1           ! Row angular momentum
                  aux4 = (0.d0,0.d0)
                  do q = -2,2
                     l = i + q                  ! Column angular momentum
                     phase = B*dble(i*(i+1)-l*(l+1))
                     phase = (0.d0,1.d0)*phase*t
                     phase = exp(phase)
                     aux4 = aux4 +                                 &
     &                    c2tmat(q,indr,M,K)*phase*n(indr+q,indc)
                  end do
                  aux3 = aux3 + conjg(n(indr,indc))*aux4
               end do

               indr = neq-1
               i = init + indr - 1
               aux4 = (0.d0,0.d0)
               do q = -2,1
                  l = i + q
                  phase = B*dble(i*(i+1)-l*(l+1))
                  phase = (0.d0,1.d0)*phase*t
                  phase = exp(phase)
                  aux4 = aux4 +                                 &
     &                 c2tmat(q,indr,M,K)*phase*n(indr+q,indc)
               end do
               aux3 = aux3 + conjg(n(indr,indc))*aux4

               indr = neq
               i = init + indr - 1
               aux4 = (0.d0,0.d0)
               do q = -2,0
                  l = i + q
                  phase = B*dble(i*(i+1)-l*(l+1))
                  phase = (0.d0,1.d0)*phase*t
                  phase = exp(phase)
                  aux4 = aux4 +                                 &
     &                 c2tmat(q,indr,M,K)*phase*n(indr+q,indc)
               end do
               aux3 = aux3 + conjg(n(indr,indc))*aux4

               aux2 = aux2 + aux3

            end do

            aux1 = aux1 + Zaux*aux2

         end do

         cos2t = cos2t + aux1

      end do
      end subroutine calcc2t
