!
! bain --- generate the potential of Bain et al.
!       from J. Phys. B *26* 4503 (1993)
! Christian Buth
! 25 May 2006
!
! /bin/rm unsinn ; g95 -r8 woods.F90 ; a.out >unsinn
!

      program bain
      use fortrantl
      implicit none

      integer i
      real(dblprec) r, rstep

      rstep = 30.0D0 / (441.0D0 - 1.0D0)

      do i=1, 441
        r = (i-1) * rstep
        ! Potential for plotting
!         write (*,*) r, Vbain(r)
        ! rV for oneel
        write (*,100) r, r * Vbain(r)
      end do

 100  format(e25.16,e25.16)


      contains

      real(dblprec) function Vbain(r)
      use fortrantl
      implicit none

      real(dblprec) r

      Vbain = 7.5D0 * r**2 * exp(-r)
      end function Vbain
      end program bain
