      subroutine sqrtmesh( rf, nodestot, xnd, nbasis, leftright )
      use fortrantl
      use FiniteElements
      implicit none

      integer nodestot
      real(dblprec) rf
      integer nbasis, leftright(2)
      type(FEBnodes) xnd
      integer j
      real(dblprec), allocatable :: nodes(:)
      real(dblprec) xnf, hx, nodespace


!! rf is the length of the grid , with the first node at r=0
!! nodestot is the input of the desired number of nodes


   ALLOCATE( nodes(10000) )

   xnf=dsqrt(rf)
   hx = xnf/dble(nodestot-1)

   DO j = 1, nodestot
     nodes(j) = (j-1)*hx
     nodes(j) = ( nodes(j) )**2
   END DO


!! CreateNodes creates xnd, a data structure containing information
!!  about finite element nodes

   CALL CreateNodes(xnd,nodes,nodestot,leftright)

   nbasis = numbasfun(xnd)

   Print*, 'The number of nodes is', nodestot
   Print*,'The number of basis functions is',nbasis

!! Calculate the spacing between the last two nodes

   nodespace = nodes(nodestot) - nodes(nodestot-1)

   Print*,'The spacing between the last two f. e. nodes is', nodespace


   DEALLOCATE( nodes )

RETURN
END SUBROUTINE sqrtmesh

